<template>
  <div class="q-pa-md">
    <h2 class="text-center big-heading">{{ t('searchBar.heading') }}</h2>
    <div class="wrapper">
      <q-input
        v-model.trim="searchedQuery"
        outlined
        color="secondary"
        :label="t('searchBar.placeHolder')"
      >
        <template #append>
          <q-icon name="search" color="secondary"></q-icon>
        </template>
      </q-input>
      <p class="text-center q-pa-sm" v-if="!searchedQuery">
        {{ t('searchBar.defaultMessage') }}
      </p>
      <p class="text-center q-pt-sm text-weight-bold" v-else>{{ message }}</p>
      <div>
        <ul
          class="no-bullets q-pa-none q-ma-none"
          v-for="person in peopleStore.people"
          :key="person.name"
        >
          <li
            class="q-pa-md q-mb-sm bg-dark text-white rounded-borders"
            v-html="highlightName(person.name)"
          ></li>
        </ul>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { usePeopleStore } from 'stores/people-store';
import { debounce } from 'quasar';
import { useI18n } from 'vue-i18n';
import { computed, ref, watch } from 'vue';
const { t } = useI18n();
const peopleStore = usePeopleStore();
const searchedQuery = ref<string>('');

const message = computed(() => {
  if (peopleStore.isLoading) {
    return '';
  } else if (!peopleStore.people.length && !peopleStore.isLoading) {
    return t('searchBar.nothingFound');
  }
  return '';
});

const getPeople = debounce(async () => {
  if (searchedQuery.value) {
    await peopleStore.searchCharacters(searchedQuery.value);
  }
}, 500);

const highlightName = (name: string) => {
  if (!searchedQuery.value) return name;

  const escapeRegExp = (string: string) => {
    return string.replace(/[.*+?^${}()|[\]\\]/g, '\\$&');
  };

  return name.replace(
    new RegExp(escapeRegExp(searchedQuery.value), 'gi'),
    (match) => `<span class="highlight">${match}</span>`
  );
};
watch(searchedQuery, (newValue) => {
  if (newValue) {
    peopleStore.isLoading = true;
    getPeople();
  } else {
    peopleStore.clearPeople();
  }
});
</script>
<style lang="scss" scoped>
.no-bullets {
  list-style: none;
}

.wrapper {
  max-width: 500px;
  margin: auto;
}
.big-heading {
  font-size: 4.3rem;
}
</style>
